#!/usr/bin/python

try:
	import SOCKS; socket = SOCKS; del SOCKS # import SOCKS as socket
	from socket import getfqdn; socket.getfqdn = getfqdn; del getfqdn
except ImportError:
	import socket
from socket import _GLOBAL_DEFAULT_TIMEOUT

import sys,os
import imp
packages_path = os.path.dirname(os.__file__)
print(os.path.dirname(socket.__file__))
fn_, path, desc = imp.find_module('ftplib',[packages_path])
_FTPC = imp.load_module('ftplib_c', fn_, path, desc)

sys.path.append("/www/server/panel/")
sys.path.append("/www/server/panel/class/")
import public,json

_plugin_path = "/www/server/panel/plugin/ftp_helper/"
_config_file = _plugin_path + 'config.json'

class _FTP(_FTPC.FTP):
	active_external_IP = None
	active_Port_min = None
	active_Port_max = None
	random_port = True
	
	def __init__(self, **args):
		_config = None
		if os.path.exists(_config_file):
			_f_body = public.ReadFile(_config_file)
			if _f_body:
				_config = json.loads(_f_body)
			if _config and ('on' in _config) and _config['on'] == '1':
				external_ip = None
				port_min = None
				port_max = None
				random_port = True
				if 'external_ip' in _config and _config['external_ip'] != '': self.active_external_IP = _config['external_ip']
				if 'min' in _config and _config['min'] != '': self.active_Port_min = int(_config['min'])
				if 'max' in _config and _config['max'] != '': self.active_Port_max = int(_config['max'])
				if 'auto_ip' in _config and _config['auto_ip']: self.active_external_IP = public.GetLocalIp()
				if 'random_port' in _config and not _config['random_port']: self.random_port = False
				self.set_pasv(False)
		
		_FTPC.FTP.__init__(self,**args)
				
	def makeport(self):
		'''Create a new socket and send a PORT command for it.'''
		err = None
		sock = None

		if self.active_Port_min is not None or self.active_Port_max is not None:
			tmp_port_min = 1025
			tmp_port_max = 65535
			if self.active_Port_min is not None:
				tmp_port_min = self.active_Port_min
			if self.active_Port_max is not None:
				tmp_port_max = self.active_Port_max
			if self.random_port:
				import random
				uports = random.sample(range(tmp_port_min,tmp_port_max+1), tmp_port_max-tmp_port_min+1)
			else:
				uports = range(tmp_port_min, tmp_port_max+1)
			for i in uports:
				for res in socket.getaddrinfo(None, i, self.af, socket.SOCK_STREAM, 0, socket.AI_PASSIVE):
					af, socktype, proto, canonname, sa = res
					try:
						sock = socket.socket(af, socktype, proto)
						sock.bind(sa)
					except socket.error as err:
						if sock:
							sock.close()
						sock = None
						continue
				
				if sock is not None: break

		if sock is None:
			for res in socket.getaddrinfo(None, 0, self.af, socket.SOCK_STREAM, 0, socket.AI_PASSIVE):
				af, socktype, proto, canonname, sa = res
				try:
					sock = socket.socket(af, socktype, proto)
					sock.bind(sa)
				except socket.error as err:
					if sock:
						sock.close()
					sock = None
					continue
				break
		
		if sock is None:
			if err is not None:
				raise err
			else:
				raise socket.error("getaddrinfo returns an empty list")
		sock.listen(1)
		port = sock.getsockname()[1] # Get proper port
		host = self.sock.getsockname()[0] # Get proper host
		if self.active_external_IP is not None:
			host = self.active_external_IP
		if self.af == socket.AF_INET:
			resp = self.sendport(host, port)
		else:
			resp = self.sendeprt(host, port)
		if self.timeout is not _GLOBAL_DEFAULT_TIMEOUT:
			sock.settimeout(self.timeout)
		return sock

try:
	import ssl
except ImportError:
	pass
else:
	class FTP_TLS(_FTPC.FTP_TLS,_FTP):
		makeport = _FTP.makeport

		def __init__(self, **args):
			_FTP.__init__(self)
			_FTPC.FTP_TLS.__init__(self,**args)

class FTP(object):
	def __new__(cls,**args):
		_config = None
		if os.path.exists(_config_file):
			_f_body = public.ReadFile(_config_file)
			if _f_body:
				_config = json.loads(_f_body)
		_Force_FTPS = False
		if _config and ('ftps' in _config) and _config['ftps'] == '1': _Force_FTPS = True
		if _Force_FTPS:
			return FTP_TLS(**args)
		else:
			return _FTP(**args)
